package java.lang;

import java.util.Spliterators;
import java.util.Spliterator;
import java.util.Objects;
import java.util.function.Consumer;
import java.util.Iterator;

public interface Iterable<T>
{
    public abstract Iterator<T> iterator();
    
    default public void forEach(Consumer<? super T> obj) {
        Objects.requireNonNull(obj);
        Iterator<T> iterator = this.iterator();
        while (iterator.hasNext()) {
            obj.accept(iterator.next());
        }
    }
    
    default public Spliterator<T> spliterator() {
        return Spliterators.spliteratorUnknownSize(this.iterator(), 0);
    }
}
